//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//|             Average Joe 
//|        Last Updated 3-1-2007 
//|$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#property copyright "Average Joe"
#property link      "Average Joe"
#define     NL      "\n" 
#include <stdlib.mqh>

extern double MALongLong          = 100;
extern double MALong              = 65;
extern double MAShort             = 10;
extern double MAShortShort        = 5;

extern double Lots                = 1;       // how many lots to trade at a time
extern int    TP                  = 40;
extern int    SL                  = 70;
extern bool   UseCrossClose       = false;

extern int    StartHour1          = 0;
extern int    EndHour1            = 10;

extern int    StartHour2          = 10;
extern int    EndHour2            = 24;

extern bool   LotIncrease         = true;  
extern int    MaxTrades           = 1;

extern bool   IsAcctMini          = true;
extern bool   EndTrading          = false;   // closes EA after all trades close
extern bool   StopTrading         = false;   // Stops All trading but allows trades to close
extern double StartingBalance     = 0;             // lot size control if LotIncrease == true

int    Slippage                = 3;             // how many pips of slippage can you tolorate
int    MagicNumber             = 293;       // allows multiple experts to trade on same account
string TradeComment            = "Average Joe "; // comment so multiple EAs can be seen in Account History
bool   TradeAllowed            = true;          // used to manage trades
datetime    bartime            = 0;                    
double BoostTrack              = 0;             // used to track compounding and steps
bool   Boost                   = false;

//+-------------+
//| Custom init |
//|-------------+
int init()
  {
      return(0);
  }

//+----------------+
//| Custom DE-init |
//+----------------+
int deinit()
  {
      return(0);
  }
    
//+------------------------------------------------------------------------+
//| Closes all BUY positions                                               |
//+------------------------------------------------------------------------+
void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  double LastBuyTime;
  
  for(int i=totalorders-1;i>=0;i--)
    {
    if(OrderSelect(i, SELECT_BY_POS)==false) break;
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if (OrderType() == OP_BUY && OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
        if (OrderType() == OP_BUY && CurTime()-LastBuyTime >=120)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
    }
  return; 
 }

//+------------------------------------------------------------------------+
//| Closes all SELL positions                                               
//+------------------------------------------------------------------------+
void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  double LastSellTime;
  
  for(int i=totalorders-1;i>=0;i--)
    {
    if(OrderSelect(i, SELECT_BY_POS)==false) break;
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  
      {
        if (OrderType() == OP_SELL && OrderOpenTime()>LastSellTime) LastSellTime=OrderOpenTime();
        if (OrderType() == OP_SELL && CurTime()-LastSellTime >=120)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
    }
  return; 
 }
 
//+------------------------------------------------------------------+
//| Check for BUY order conditions                                
//+------------------------------------------------------------------+
void CheckForBuy()
  {
   double   BuyOrders, LowestBuy=1000;
   int      cnt=0;
   int      gle=0;
   int      res;

   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
         {
          if (OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber)
            {
              BuyOrders++;
              if(OrderOpenPrice()<LowestBuy) LowestBuy=OrderOpenPrice();
            }
         }
     }
     
    if(LotIncrease && StartingBalance!=0)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50 && IsAcctMini) Lots=50;
      if(Lots>100 && !IsAcctMini) Lots=100;
    }
     
   if(TradeAllowed)
     {
       res=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-SL*Point,Ask+TP*Point,TradeComment,MagicNumber,Blue);
         
         gle=GetLastError();
         if(gle==0)
           {
            BoostTrack=Close[0];
            TradeAllowed=false;
           }
       }
   }
    
//+------------------------------------------------------------------+
//| Check for SELL order conditions                                  
//+------------------------------------------------------------------+
void CheckForSell()
  {
   double   SellOrders, HighestSell;
   int      cnt=0;
   int      gle=0;
   int      res;
      
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      BoostTrack=0;
      TradeAllowed=true;
     }
     
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
     if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==false) break;
      if( OrderSymbol()==Symbol())
        {
          if (OrderType() == OP_SELL && OrderMagicNumber()==MagicNumber)
            {
              SellOrders++;
              if(OrderOpenPrice()>HighestSell) HighestSell=OrderOpenPrice();
            }
        }
     } 
    
   if(LotIncrease && StartingBalance!=0)
     {
      Lots=NormalizeDouble(AccountBalance()/StartingBalance,2);
      if(Lots>50  && IsAcctMini)  Lots=50;
      if(Lots>100 && !IsAcctMini) Lots=100;
     }
     

   if(TradeAllowed)
     {
       res=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,TradeComment,MagicNumber,Orange);
         
         gle=GetLastError();
         if(gle==0)
           {
           BoostTrack=Close[0];
           TradeAllowed=false;
           }
       }
   }

//+--------------------------------------------------+
//|  Main Start Routine                              
//+--------------------------------------------------+
int start()
  {
   
   double   OrdersSELL, OrdersBUY, LastBuyTime, LastSellTime;
   double   BuyLots, SellLots, BuyProfit, SellProfit;
   int      CurrentTime = TimeHour(TimeCurrent());
   bool     SELLme=false, BUYme=false;
   double   Spread = Ask-Bid;
   double   MALL = iMA(NULL,0,MALongLong,0,MODE_SMA,PRICE_MEDIAN,0);
   double   MAL  = iMA(NULL,0,MALong,0,MODE_SMA,PRICE_MEDIAN,0);
   double   MAS1  = iMA(NULL,0,MAShort,0,MODE_SMA,PRICE_MEDIAN,0);
   double   MAS2  = iMA(NULL,0,MAShort,0,MODE_SMA,PRICE_MEDIAN,3);
   double   MASS1  = iMA(NULL,0,MAShortShort,0,MODE_SMA,PRICE_MEDIAN,0);
   double   MASS2 = iMA(NULL,0,MAShortShort,0,MODE_SMA,PRICE_MEDIAN,3);
      
   for(int i = 0; i < OrdersTotal(); i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) break;
       if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY && OrderOpenTime()>LastBuyTime) LastBuyTime=OrderOpenTime();
           if(OrderType() == OP_SELL && OrderOpenTime()>LastSellTime) LastSellTime=OrderOpenTime();
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if(OrderType() == OP_BUY)  BuyProfit += OrderProfit() + OrderCommission() + OrderSwap();
           if(OrderType() == OP_SELL) SellProfit += OrderProfit() + OrderCommission() + OrderSwap();
        }
     }

    if(UseCrossClose && MASS1<MAL && MAS1<MAL) CloseAllThisSymbolBuy();
    if(UseCrossClose && MASS1>MAL && MAS1>MAL) CloseAllThisSymbolSell();
    
 if((OrdersBUY + OrdersSELL < MaxTrades && CurrentTime >=StartHour1 && CurrentTime<EndHour1) || (OrdersBUY + OrdersSELL < MaxTrades && CurrentTime>=StartHour2 && CurrentTime<EndHour2))  
    {
 
//  Buys  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    if (Bid>MALL && MAL>MALL && MAS1>MAL && MASS1>MAL && MASS1>MAS1 && MASS2<MAS2)   
       {
       BUYme=true;  
       if(Boost && BoostTrack>0 && Close[0]<BoostTrack)
         {
         BUYme=true;
         TradeAllowed=true;
         }
      }
    if (EndTrading == true && OrdersBUY == 0) BUYme = false;
    if (BUYme == true && !StopTrading) CheckForBuy();
   
//  Sells  $$$$$$$$$$$$$$$$$$$$$$$$

    if (Ask<MALL && MAL<MALL && MAS1<MAL && MASS1<MAL && MASS1<MAS1 && MASS2>MAS2)  
       {
       SELLme=true; 
       if(Boost && BoostTrack>0 && Close[0]>BoostTrack)
        {
         SELLme=true; 
         TradeAllowed=true;
        }
     } 
    if (EndTrading == true && OrdersSELL == 0) SELLme = false;
    if (SELLme == true && !StopTrading) CheckForSell();
  }
 
   double margin = AccountMargin(); if (margin==0) margin=AccountEquity();
   Comment("                    Average Joe Last Update 3-1-2007", NL,
           "                            Buys    ", OrdersBUY, NL,
           "                            BuyLots        ", BuyLots, NL,
           "                            Sells    ", OrdersSELL, NL,
           "                            SellLots        ", SellLots, NL,
           "                            Balance ", AccountBalance(), NL,
           "                            Equity        ", AccountEquity(), NL,
           "                            Margin              ", AccountMargin(), NL,
           "                            MarginPercent        ", MathRound((AccountEquity()/margin)*100), NL,
           "                            Current Time is  ",TimeHour(CurTime()),":",TimeMinute(CurTime()),".",TimeSeconds(CurTime()));   

   return(0);
 } // end start()

